import datetime
import time
from subprocess import *
import sys


# function for parsing hex string into mac address format
def eth_addr(a):
    b = "%s:%s:%s:%s:%s:%s" % (a[0:2], a[2:4], a[4:6], a[6:8], a[8:10], a[10:12])
    return b

# function for backward compatibility
def my_print(text):
    sys.stdout.write(str(text))
    sys.stdout.flush()


class Handle:
    # global variables
    hds_ip = None
    hds_mac = None

    # constructor
    def __init__(self, rec, send):
        self.sender = send
        self.manage_traffic(rec)
        pass

    # handover
    def do_handover(self):
        pass

    # listening traffic, calling rest-api
    def manage_traffic(self, rec):

        # parsing the packet so we can use the fields
        while True:
            self.hds_ip = None
            self.hds_mac = None
            packet = rec.soc.recvfrom(65565)
            packet = packet[0]
            rec.read_incoming_aslan_packet(packet)
            # print rec.eth_protocol
            # print rec.protocol

            # the team agreed, that for communication between HDS <-> AFCP, the port 8215 will be used
            # some parameters are for future use
            if rec.eth_protocol == 8 and rec.protocol == 17 and rec.dest_port == 8215:
                self.hds_ip = rec.s_addr
                self.hds_mac = rec.src_mac
                hds_port = rec.source_port
                current_time = datetime.datetime.now()

                # aslan connect/disconnect sta, in ASLAN protocol the number is 13
                # for rest api, we need the wtp mac in decimal format
                if rec.data[:2] == "0d":
                    wtp_mac = int(rec.data[2:14], 16)
                    sta_mac = eth_addr(rec.data[14:26])
                    flag = rec.data[26:28]
                    # get all connected switches and parse them into wtp_list
                    cmd = ["curl", "-X", "GET", "http://localhost:8080/stats/switches"]
                    p = Popen(cmd, stdout=PIPE, stderr=STDOUT).communicate()
                    line = (p[0].splitlines())[5]
                    # line = list[5]
                    wtp_list = line.strip("[]").split(", ")
                    # flag 00 means connect
                    if flag == "00":
                        for wtp in wtp_list:
                            call([
                                "curl -X POST -d '{"
                                    "\"dpid\": " + wtp +
                                    ",\"priority\": 32768,"
                                    "\"match\": {\"dl_src\":\"" + sta_mac + "\"},"
                                    "\"actions\":[{\"type\":\"OUTPUT\",\"port\": 1}]}' "
                                    "http://localhost:8080/stats/flowentry/add"],
                                shell=True)
                            call([
                                "curl -X POST -d '{"
                                    "\"dpid\": " + wtp + ""
                                    ",\"priority\": 32768,"
                                    "\"match\": {\"dl_dst\":\"" + sta_mac + "\"},"
                                    "\"actions\":[{\"type\":\"OUTPUT\",\"port\": 4}]}' "
                                    "http://localhost:8080/stats/flowentry/add"],
                                shell=True)
                        pass
                        call([
                            "curl -X POST -d '{"
                                "\"dpid\": " + str(wtp_mac) + ","
                                "\"match\": {\"dl_dst\":\"" + sta_mac + "\"},"
                                "\"actions\":[{\"type\":\"OUTPUT\",\"port\": 6}]}' "
                                "http://localhost:8080/stats/flowentry/modify"],
                            shell=True)
                    # every other flag than 00 is disconnect
                    else:
                        for wtp in wtp_list:
                            call([
                                "curl -X POST -d '{"
                                    "\"dpid\": " + wtp + ","
                                    "\"match\": {\"dl_dst\":\"" + sta_mac + "\"}}' "
                                    "http://localhost:8080/stats/flowentry/delete"],
                                shell=True)
                            call([
                                "curl -X POST -d '{"
                                    "\"dpid\": " + wtp + ","
                                    "\"match\": {\"dl_src\":\"" + sta_mac + "\"}}' "
                                    "http://localhost:8080/stats/flowentry/delete"],
                                shell=True)
                        pass
                    pass
                # ASLAN protocol number 14 means handover, the most important thing
                elif rec.data[:2] == "0e":
                    print datetime.datetime.now()
                    wtp_mac_src = int(rec.data[2:14], 16)
                    wtp_mac_dst = int(rec.data[14:26], 16)
                    sta_mac_handover = eth_addr(rec.data[26:38])
                    call([
                        "curl -X POST -d '{"
                            "\"dpid\": " + str(wtp_mac_dst) + ","
                            "\"match\": {\"dl_dst\":\"" + sta_mac_handover + "\"},"
                            "\"actions\":[{\"type\":\"OUTPUT\",\"port\": 6}]}' "
                            "http://localhost:8080/stats/flowentry/modify"],
                        shell=True)
                    call([
                        "curl -X POST -d '{"
                            "\"dpid\": " + str(wtp_mac_src) + ","
                            "\"match\": {\"dl_dst\":\"" + sta_mac_handover + "\"},"
                            "\"actions\":[{\"type\":\"OUTPUT\",\"port\": 4}]}' "
                            "http://localhost:8080/stats/flowentry/modify"],
                        shell=True)
                    print datetime.datetime.now()
                    # sending ACK to HDS to let it know, that handover is finished
                    self.sender.send_ack(self.hds_ip, hds_port, "00")
                    print "HDS_IP:" + self.hds_ip
                    print "HDS_PORT:" + str(hds_port)
                    pass

                # optional next message
                elif rec.data[:2] == "0f":
                    pass
