import socket
import sys
from struct import *
import binascii


def eth_addr(a):
    b = "%.2x:%.2x:%.2x:%.2x:%.2x:%.2x" % (ord(a[0]), ord(a[1]), ord(a[2]), ord(a[3]), ord(a[4]), ord(a[5]))
    return b


class Receiver:
    # constructor
    def __init__(self, soc):
        try:
            self.soc = soc
        except socket.error:
            print 'Error'
            sys.exit()

    # received packet is parsed and important data are stored in fields or tuples
    def read_incoming_aslan_packet(self, packet):
        eth_length = 14
        eth_header = packet[:eth_length]
        eth = unpack('!6s6sH', eth_header)
        self.src_mac = eth_addr(packet[6:12])
        self.dst_mac = eth_addr(packet[0:6])
        self.eth_protocol = socket.ntohs(eth[2])
        if self.eth_protocol == 8:
            ip_header = packet[eth_length: 20 + eth_length]
            iph = unpack('!BBHHHBBH4s4s', ip_header)
            version_ihl = iph[0]
            version = version_ihl >> 4
            ihl = version_ihl & 0xF
            iph_length = ihl * 4
            self.protocol = iph[6]
            self.s_addr = socket.inet_ntoa(iph[8])
            self.d_addr = socket.inet_ntoa(iph[9])
            if self.protocol == 17:
                u = iph_length + eth_length
                udph_length = 8
                udp_header = packet[u:u + 8]
                udph = unpack('!HHHH', udp_header)
                self.source_port = udph[0]
                self.dest_port = udph[1]
                h_size = eth_length + iph_length + udph_length
                self.data = packet[h_size:].encode("hex")
