# tento subor sluzi cisto iba na komunikaciu medzi wtp, hds a afcp
import socket, sys
from struct import *
import binascii

def eth_addr(a):
	b = "%.2x:%.2x:%.2x:%.2x:%.2x:%.2x" % (ord(a[0]), ord(a[1]), ord(a[2]), ord(a[3]), ord(a[4]), ord(a[5]))
	return b
# trieda na prijimanie paketov
class Receiver:

    soc = socket.socket(socket.AF_PACKET, socket.SOCK_RAW, socket.ntohs(0x0003))

    # konstruktor
    def __init__(self, soc):
        try:
            self.soc = soc
        except socket.error , msg:
            print 'Error'
            sys.exit()

    # prijaty paket sa rozoberie a vsetky podstatne udaje sa ulozia do pola alebo do tuple
    def read_incoming_aslan_packet(self, packet):
        eth_length = 14
        eth_header = packet[:eth_length]
        eth = unpack('!6s6sH', eth_header)
        self.eth_protocol = socket.ntohs(eth[2])
        if self.eth_protocol == 8:
			ip_header = packet[eth_length: 20 + eth_length]
			iph = unpack('!BBHHHBBH4s4s', ip_header)
			version_ihl = iph[0]
			version = version_ihl >> 4
			ihl = version_ihl & 0xF
			iph_length = ihl * 4
			self.protocol = iph[6]
			self.s_addr = socket.inet_ntoa(iph[8])
			d_addr = socket.inet_ntoa(iph[9])
			if self.protocol == 17:
				u = iph_length + eth_length
				udph_length = 8
				udp_header = packet[u:u+8]
				udph = unpack('!HHHH', udp_header)
				self.source_port = udph[0]
				self.dest_port = udph[1]
				h_size = eth_length + iph_length + udph_length
				self.data = packet[h_size:]

# trieda na odosielanie paketov pre wtp ale aj afcp
class Sender:

    soc = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

    # konstruktor
    def __init__(self, soc):
        try:
            self.soc = soc
        except socket.error, msg:
            print 'Error'
            sys.exit()

# nizsie su vsetky typy paketov, ktore sa budu odosielat do wtp
    def send_aslan_initialisation_response(self, IP, port):
        sprava = "6"
        self.soc.sendto(sprava,(IP,port))

    def send_aslan_context_response(self, IP, port, sta_mac, bssid):
        sprava = "7" + sta_mac + bssid
        self.soc.sendto(sprava,(IP,port))

    def send_aslan_authentication_response(self):
        self

    def send_aslan_handover_request(self, IP, port, sta_mac, bssid, sta_context):
        sprava = "9" + sta_mac + bssid + sta_context
        self.soc.sendto(sprava,(IP,port))

    def send_aslan_release_request(self, IP, port, sta_mac):
        sprava = binascii.unhexlify("10") + sta_mac
        self.soc.sendto(sprava,(IP,port))

    def send_aslan_flush_request(self, IP, port):
        sprava = binascii.unhexlify("11")
        self.soc.sendto(sprava,(IP,port))

    def send_ack(self, IP, port, priznak):
        sprava = binascii.unhexlify("12") + priznak
        self.soc.sendto(sprava,(IP,port))

    #bude tu pravdepodobne viac metod pre rozkazovanie afcp
    def send_commands_to_aftcp(self):
        self